Unit PA09R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, PA02R_p;

procedure PA09R(XR :Real; XI :Real; N :Integer; var YR :Array of Real;
                var YI :Array of Real);

implementation

procedure PA09R(XR :Real; XI :Real; N :Integer; var YR :Array of Real;
                var YI :Array of Real);
var
K :Integer;
ODN,TETA,TETAN,R1,R2,TPN,R :Real;
const
SYS001 :Real = 3.1415926535897932384626433832795;
SYS003 :Real = 6.2831853071795864769252867665590;
SYS005 :Real = 1.5707963267948966192313216916397;
ONE :Real = 1.0E0;
ZERO :Real = 0.0E0;
label
_10,_20,_30,_40,_50;
begin
ODN := ONE/N;
R := Power(PA02R(XR,XI),ODN);
if ( XR > ZERO ) 
 then goto _10;
if ( XR < ZERO ) 
 then goto _20;
TETA := Sign(SYS005,XI);
goto _30;
_10:
TETA := ArcTan(XI/XR);
goto _30;
_20:
TETA := ArcTan(XI/XR)+SYS001;
_30:
TETAN := TETA*ODN;
TPN := SYS003*ODN;
R1 := Cos(TPN);
R2 := Sin(TPN);
YR[0] := Cos(TETAN);
YI[0] := Sin(TETAN);
for K:=2 to N do
 begin
  YR[K-1] := YR[K-2]*R1-YI[K-2]*R2;
  YI[K-1] := YI[K-2]*R1+YR[K-2]*R2;
_40:
 end;
for K:=1 to N do
 begin
  YR[K-1] := YR[K-1]*R;
  YI[K-1] := YI[K-1]*R;
_50:
 end;
end;

end.
